



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python动态获取对象的属性和方法 （转）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python动态获取对象的属性和方法 （转）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 09:46:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转自未知，纯个人笔记使用</p>
<p>首先通过一个例子来看一下本文中可能用到的对象和相关概念。</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8<br />
import sys

def foo():pass

class Cat(object):<br />
    def __init__(self, name='Kitty'):<br />
        self.name = name

    def sayHi(self):<br />
        print self.name, 'says Hi!'

cat = Cat()

print Cat.sayHi<br />
print cat.sayHi</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>有时候我们会碰到这样的需求，需要执行对象的某个方法，或是需要对对象的某个字段赋值，而方法名或是字段名在编码代码时并不能确定，需要通过参数传递字符串的形式输入。举个具体的例子：当我们需要实现一个通用的DBM框架时，可能需要对数据对象的字段赋值，但我们无法预知用到这个框架的数据对象都有些什么字段，换言之，我们在写框架的时候需要通过某种机制访问未知的属性。</p>
<p>这个机制被称为反射（反过来让对象告诉我们他是什么），或是自省（让对象自己告诉我们他是什么，好吧我承认括号里是我瞎掰的- -#），用于实现在运行时获取未知对象的信息。反射是个很吓唬人的名词，听起来高深莫测，在一般的编程语言里反射相对其他概念来说稍显复杂，一般来说都是作为高级主题来讲；但在Python中反射非常简单，用起来几乎感觉不到与其他的代码有区别，使用反射获取到的函数和方法可以像平常一样加上括号直接调用，获取到类后可以直接构造实例；不过获取到的字段不能直接赋值，因为拿到的其实是另一个指向同一个地方的引用，赋值只能改变当前的这个引用而已。</p>
<p><strong>1. 访问对象的属性</strong></p>
<p>以下列出了几个内建方法，可以用来检查或是访问对象的属性。这些方法可以用于任意对象而不仅仅是例子中的Cat实例对象；<strong>Python中一切都是对象。</strong></p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8<br />
from a import *

cat = Cat('kitty')

print cat.name<br />
cat.sayHi()    #调用实例方法

print dir(cat)

if hasattr(cat, 'name'): #检查实例是否有这个属性<br />
    setattr(cat, 'name', 'tiger') #same as: a.name = 'tiger'<br />
    print getattr(cat, 'name') #same as: print a.name

getattr(cat, 'sayHi')()</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><strong>dir([obj]):</strong><br />&nbsp;&nbsp;&nbsp; 调用这个方法将返回包含obj大多数属性名的列表（会有一些特殊的属性不包含在内）。obj的默认值是当前的模块对象。<br />&nbsp;&nbsp;&nbsp;<strong>&nbsp;hasattr(obj, attr):&nbsp;</strong><br />&nbsp;&nbsp;&nbsp; 这个方法用于检查obj是否有一个名为attr的值的属性，返回一个布尔值。<br />&nbsp;&nbsp;&nbsp;<strong>&nbsp;getattr(obj, attr):&nbsp;</strong><br />&nbsp;&nbsp;&nbsp; 调用这个方法将返回obj中名为attr值的属性的值，例如如果attr为&rsquo;bar&rsquo;，则返回obj.bar。<br />&nbsp;&nbsp;&nbsp;&nbsp;<strong>setattr(obj, attr, val):</strong><br />&nbsp;&nbsp;&nbsp; 调用这个方法将给obj的名为attr的值的属性赋值为val。例如如果attr为&rsquo;bar&rsquo;，则相当于obj.bar = val。</p>
<p><strong>2. 访问对象的元数据</strong></p>
<p>当你对一个你构造的对象使用dir()时，可能会发现列表中的很多属性并不是你定义的。这些属性一般保存了对象的元数据，比如类的__name__属性保存了类名。大部分这些属性都可以修改，不过改动它们意义并不是很大；修改其中某些属性如function.func_code还可能导致很难发现的问题，所以改改name什么的就好了，其他的属性不要在不了解后果的情况下修改。</p>
<p>接下来列出特定对象的一些特殊属性。另外，Python的文档中有提到部分属性不一定会一直提供，下文中将以红色的星号*标记，使用前你可以先打开解释器确认一下。</p>
<h3>2.0. 准备工作：确定对象的类型</h3>
<p>在types模块中定义了全部的Python内置类型，结合内置方法isinstance()就可以确定对象的具体类型了。</p>
<ul><li><strong>isinstance(object, classinfo):</strong>&nbsp;<br />检查object是不是classinfo中列举出的类型，返回布尔值。classinfo可以是一个具体的类型，也可以是多个类型的元组或列表。</li></ul>
<p>types模块中仅仅定义了类型，而inspect模块中封装了很多检查类型的方法，比直接使用types模块更为轻松，所以这里不给出关于types的更多介绍，如有需要可以直接查看types模块的文档说明。本文第3节中介绍了inspect模块。</p>
<h3>2.1. 模块(module)</h3>
<ul><li>__doc__: 文档字符串。如果模块没有文档，这个值是None。</li>
<li><strong>*</strong>__name__: 始终是定义时的模块名；即使你使用import .. as 为它取了别名，或是赋值给了另一个变量名。</li>
<li><strong>*</strong>__dict__: 包含了模块里可用的属性名-属性的字典；也就是可以使用模块名.属性名访问的对象。</li>
<li>__file__: 包含了该模块的文件路径。需要注意的是内建的模块没有这个属性，访问它会抛出异常！</li></ul>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8<br />
import fnmatch as m

print m.__doc__.splitlines()[0]<br />
print m.__name__<br />
print m.__file__<br />
print m.__dict__.items()[0]</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/654185/201611/654185-20161104173056861-402860390.png" /></p>
<p>__dict__ 返回属性、方法对象名值的字典，而dir仅仅是个属性、方法名的列表。</p>
<h3>2.2. 类(class)</h3>
<ul><li>__doc__: 文档字符串。如果类没有文档，这个值是None。</li>
<li><strong>*</strong>__name__: 始终是定义时的类名。</li>
<li><strong>*</strong>__dict__: 包含了类里可用的属性名-属性的字典；也就是可以使用类名.属性名访问的对象。</li>
<li>__module__: 包含该类的定义的模块名；需要注意，是字符串形式的模块名而不是模块对象。</li>
<li><strong>*</strong>__bases__: 直接父类对象的元组；但不包含继承树更上层的其他类，比如父类的父类</li></ul>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8<br />
from a import *

print Cat.__doc__ #None Cat类没有doc<br />
print Cat.__name__ #Cat<br />
print Cat.__module__ # a 如果在自身的module中执行时__main__<br />
print Cat.__bases__ #(&lt;type 'object'&gt;,)<br />
print Cat.__dict__ # 一个属性、方法对象名值的字典</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>2.3. 实例(instance)</h3>
<p>实例是指类实例化以后的对象。</p>
<ul><li><strong>*</strong>__dict__: 包含了可用的属性名-属性对象字典。</li>
<li><strong>*</strong>__class__: 该实例的类对象。对于类Cat，cat.__class__ == Cat 为 True。</li></ul>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8<br />
from a import *

print cat.__dict__ #{'name': 'Kitty'} 仅仅有属性，没有方法<br />
print cat.__class__ #&lt;class 'a.Cat'&gt;<br />
print cat.__class__ == Cat #True</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>2.4. 内建函数和方法(built-in functions and methods)</h3>
<p>根据定义，内建的(built-in)模块是指使用C写的模块，可以通过sys模块的builtin_module_names字段查看都有哪些模块是内建的。这些模块中的函数和方法可以使用的属性比较少，不过一般也不需要在代码中查看它们的信息。</p>
<ul><li>__doc__: 函数或方法的文档。</li>
<li>__name__: 函数或方法定义时的名字。</li>
<li>__self__: 仅方法可用，如果是绑定的(bound)，则指向调用该方法的类（如果是类方法）或实例（如果是实例方法），否则为None。</li>
<li><strong>*</strong>__module__: 函数或方法所在的模块名。</li></ul>
<h3>2.5. 函数(function)</h3>
<p>这里特指非内建的函数。注意，在类中使用def定义的是方法，方法与函数虽然有相似的行为，但它们是不同的概念。</p>
<ul><li>__doc__: 函数的文档；另外也可以用属性名func_doc。</li>
<li>__name__: 函数定义时的函数名；另外也可以用属性名func_name。</li>
<li><strong>*</strong>__module__: 包含该函数定义的模块名；同样注意，是模块名而不是模块对象。</li>
<li><strong>*</strong>__dict__: 函数的可用属性；另外也可以用属性名func_dict。 &nbsp;不要忘了函数也是对象，可以使用函数.属性名访问属性（赋值时如果属性不存在将新增一个），或使用内置函数has/get/setattr()访问。不过，在函数中保存属性的意义并不大。</li></ul>
<ul><li>func_defaults: 这个属性保存了函数的参数默认值元组；因为默认值总是靠后的参数才有，所以不使用字典的形式也是可以与参数对应上的。</li>
<li>func_code: 这个属性指向一个该函数对应的code对象，code对象中定义了其他的一些特殊属性，将在下文中另外介绍。</li>
<li>func_globals: 这个属性指向当前的全局命名空间而不是定义函数时的全局命名空间，用处不大，并且是只读的。</li>
<li><strong>*</strong>func_closure: 这个属性仅当函数是一个闭包时有效，指向一个保存了所引用到的外部函数的变量cell的元组，这个属性也是只读的。（通过func_closure可以查看必报）</li></ul>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8<br />
def foo():<br />
    name = 'zhangsan'<br />
    age = 11

    def bar():<br />
        print name, age

    return bar

closure = foo()

print closure.func_closure<br />
# (&lt;cell at 0x7f2fa7d36558: int object at 0x19f7b78&gt;, &lt;cell at 0x7f2fa7d36590: str object at 0x7f2fa7d37450&gt;)

for cell in closure.func_closure:<br />
    print cell.cell_contents<br />
    # zhangsan<br />
    # 11</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>2.6. 方法(method)</h3>
<p><strong>方法虽然不是函数，但可以理解为在函数外面加了一层外壳</strong>；拿到方法里实际的函数以后，就可以使用2.5节的属性了。</p>
<ul><li>__doc__: 与函数相同。</li>
<li>__name__: 与函数相同。</li>
<li><strong>*</strong>__module__: 与函数相同。</li>
<li>im_func: 使用这个属性可以拿到方法里实际的函数对象的引用。另外如果是2.6以上的版本，还可以使用属性名__func__。</li>
<li>im_self: 如果是绑定的(bound)，则指向调用该方法的类（如果是类方法）或实例（如果是实例方法），否则为None。如果是2.6以上的版本，还可以使用属性名__self__。</li>
<li>im_class: 实际调用该方法的类，或实际调用该方法的实例的类。注意不是方法的定义所在的类，如果有继承关系的话。</li></ul>
<p>这里讨论的是一般的实例方法，另外还有两种特殊的方法分别是类方法(classmethod)和静态方法(staticmethod)。类方法还是方法，不过因为需要使用类名调用，所以他始终是绑定的；<strong>而静态方法可以看成是在类的命名空间里的函数（需要使用类名调用的函数），它只能使用函数的属性，不能使用方法的属性。</strong></p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8

class Dog(object):<br />
    def imeth(self):<br />
        print 'instance method ', self

    @classmethod<br />
    def cmeth(cls):<br />
        print 'class method ', cls

    @staticmethod<br />
    def smeth():<br />
        print 'static method '

dog = Dog()<br />
dog.imeth() #实例调用 绑定方法<br />
Dog.imeth(dog) #类调用 未绑定方法

Dog.cmeth() # 类调用类方法<br />
Dog.smeth() # 类调用静态方法

# 实例虽然也可以调用 类方法和静态方法，但是没有多大意义，类方法依旧绑定类本身<br />
dog.cmeth()<br />
dog.smeth()

print '============================'

print dog.imeth.__self__ #&lt;__main__.Dog object at 0x7f9a69d04e10&gt;<br />
print Dog.imeth.__self__ #None 未绑定<br />
print Dog.cmeth.__self__ #&lt;class '__main__.Dog'&gt;<br />
print dog.cmeth.__self__ #&lt;class '__main__.Dog'&gt; 使用实例调用类方法没有多大意义，依旧绑定类本身<br />
#print Dog.smeth.__self__ # 静态方法可以理解为类中的函数（function），所以没有__self__</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>2.7. 生成器(generator)</h3>
<p>生成器是调用一个生成器函数(generator function)返回的对象，多用于集合对象的迭代。</p>
<ul><li>__iter__: 仅仅是一个可迭代的标记。</li>
<li>gi_code: 生成器对应的code对象。</li>
<li>gi_frame: 生成器对应的frame对象。</li>
<li>gi_running: 生成器函数是否在执行。生成器函数在yield以后、执行yield的下一行代码前处于frozen状态，此时这个属性的值为0。</li>
<li>next|close|send|throw: 这是几个可调用的方法，并不包含元数据信息，如何使用可以查看生成器的相关文档。</li></ul>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8

def gen():<br />
    for n in xrange(5):<br />
        yield n

g = gen()

print g<br />
print g.gi_code<br />
print g.gi_frame<br />
print g.gi_running</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>接下来讨论的是几个不常用到的内置对象类型。这些类型在正常的编码过程中应该很少接触，除非你正在自己实现一个解释器或开发环境之类。所以这里只列出一部分属性，如果需要一份完整的属性表或想进一步了解，可以查看文末列出的参考文档。</p>
<h3>2.8. 代码块(code)</h3>
<p>代码块可以由类源代码、函数源代码或是一个简单的语句代码编译得到。这里我们只考虑它指代一个函数时的情况；2.5节中我们曾提到可以使用函数的func_code属性获取到它。code的属性全部是只读的。</p>
<ul><li>co_argcount: 普通参数的总数，不包括*参数和**参数。</li>
<li>co_varnames: 所有的参数名（包括*参数和**参数）和局部变量名的元组。</li>
<li>co_filename: 源代码所在的文件名。</li>
<li>co_flags:&nbsp; 这是一个数值，每一个二进制位都包含了特定信息。较关注的是0b100(0&times;4)和0b1000(0&times;8)，如果co_flags &amp; 0b100 != 0，说明使用了*args参数；如果co_flags &amp; 0b1000 != 0，说明使用了**kwargs参数。另外，如果co_flags &amp; 0b100000(0&times;20) != 0，则说明这是一个生成器函数(generator function)</li></ul>
<p><strong>（<strong>我的理解是code代表了类、函数代码本身的一些特征</strong>）</strong></p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8

def foo(name, age=11, home='CHN', *args, **kwargs):<br />
    inner = 'inner'

co = foo.func_code<br />
print co.co_argcount #3 普通参数 name age home<br />
print co.co_varnames<br />
# ('name', 'age', 'home', 'args', 'kwargs', 'inner')<br />
print co.co_flags &amp; 0b100 #4 表明使用了*args</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>2.9. 栈帧(frame)</h3>
<p>栈帧表示程序运行时函数调用栈中的某一帧。函数没有属性可以获取它，因为它在函数调用时才会产生，而<strong>生成器则是由函数调用返回的，所以有属性指向栈帧（我的理解就是生成器是动态的）</strong>。想要获得某个函数相关的栈帧，则必须在调用这个函数且这个函数尚未返回时获取。你可以使用sys模块的_getframe()函数、或inspect模块的currentframe()函数获取当前栈帧。这里列出来的属性全部是只读的。</p>
<ul><li>f_back: 调用栈的前一帧。</li>
<li>f_code: 栈帧对应的code对象。</li>
<li>f_locals: 用在当前栈帧时与内建函数locals()相同，但你可以先获取其他帧然后使用这个属性获取那个帧的locals()。</li>
<li>f_globals: 用在当前栈帧时与内建函数globals()相同，但你可以先获取其他帧&hellip;&hellip;。</li></ul>
<h3>2.10. 追踪(traceback)</h3>
<p>追踪是在出现异常时用于回溯的对象，与栈帧相反。由于异常时才会构建，而异常未捕获时会一直向外层栈帧抛出，所以需要使用try才能见到这个对象。你可以使用sys模块的exc_info()函数获得它，这个函数返回一个元组，元素分别是异常类型、异常对象、追踪。traceback的属性全部是只读的。</p>
<ul><li>tb_next: 追踪的下一个追踪对象。</li>
<li>tb_frame: 当前追踪对应的栈帧。</li>
<li>tb_lineno: 当前追踪的行号。</li></ul>
<h2>3. 使用inspect模块</h2>
<p>inspect模块提供了一系列函数用于帮助使用自省。下面仅列出较常用的一些函数，想获得全部的函数资料可以查看inspect模块的文档。</p>
<h3>3.1. 检查对象类型</h3>
<ul><li><strong>is{module|class|function|method|builtin}(obj):&nbsp;</strong>检查对象是否为模块、类、函数、方法、内建函数或方法。</li></ul>
<ul><li><strong>isroutine(obj): &nbsp;</strong>用于检查对象是否为函数、方法、内建函数或方法等等可调用类型。用这个方法会比多个is*()更方便，不过它的实现仍然是用了多个is*()。</li></ul>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8<br />
import inspect

print inspect.ismodule(inspect) #True<br />
print inspect.isfunction(inspect.isfunction) #True<br />
print inspect.isbuiltin(sorted) #True<br />
print inspect.isroutine(sorted) #True</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>对于实现了__call__的类实例，这个方法会返回False。如果目的是只要可以直接调用就需要是True的话，不妨使用<strong>isinstance(obj, collections.Callable)</strong>这种形式。我也不知道为什么Callable会在collections模块中，抱歉！我猜大概是因为collections模块中包含了很多其他的ABC(Abstract Base Class)的缘故吧：）</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8<br />
import collections

class Dog(object):<br />
    def __call__(self, name):#实现__call__方法就可以直接调用对象了<br />
        print 'i am a dog named ' , name

dog = Dog()<br />
dog('DaHuang')

print isinstance(dog, collections.Callable) #True

print dog.__class__.__bases__</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>3.2. 获取对象信息</h3>
<ul><li><strong>getmembers(object[, predicate]):</strong>&nbsp;这个方法是dir()的扩展版，它会将dir()找到的名字对应的属性一并返回，形如[(name, value), ...]。另外，predicate是一个方法的引用，如果指定，则应当接受value作为参数并返回一个布尔值，如果为False，相应的属性将不会返回。使用is*作为第二个参数可以过滤出指定类型的属性。</li>
<li><strong>getmodule(object):</strong>还在为第2节中的__module__属性只返回字符串而遗憾吗？这个方法一定可以满足你，它返回object的定义所在的模块对象。</li>
<li><strong>get{file|sourcefile}(object):</strong>获取object的定义所在的模块的文件名|源代码文件名（如果没有则返回None）。用于内建的对象（内建模块、类、函数、方法）上时会抛出TypeError异常。</li>
<li><strong>get{source|sourcelines}(object):</strong>获取object的定义的源代码，以字符串|字符串列表返回。代码无法访问时会抛出IOError异常。只能用于module/class/function/method/code/frame/traceack对象。</li></ul>
<ul><li><strong>getargspec(func):&nbsp;</strong>仅用于方法，获取方法声明的参数，返回元组，分别是(普通参数名的列表, *参数名, **参数名, 默认值元组)。如果没有值，将是空列表和3个None。如果是2.6以上版本，将返回一个命名元组(Named Tuple)，即除了索引外还可以使用属性名访问元组中的元素。</li></ul>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8<br />
import inspect<br />
from a import *

print inspect.getmembers(Cat, inspect.ismethod)<br />
#[('__init__', &lt;unbound method Cat.__init__&gt;), ('sayHi', &lt;unbound method Cat.sayHi&gt;)]

print cat.__module__ #str<br />
print inspect.getmodule(cat) #&lt;module 'a' from '/tmp/zc/a.pyc'&gt; module 对象

print inspect.getfile(Cat) #/tmp/zc/a.pyc

print inspect.getsource(Cat) # 返回源代码（觉得这个挺酷的！！！）<br />
"""<br />
class Cat(object):<br />
    def __init__(self, name='Kitty'):<br />
        self.name = name

    def sayHi(self):<br />
        print self.name, 'says Hi!'<br />
"""<br />
class Dog(object):<br />
    def foo(self, name, age=11, home='CHN', *args, **kwargs):<br />
        pass

print inspect.getargspec(Dog.foo)<br />
#ArgSpec(args=['self', 'name', 'age', 'home'], varargs='args', keywords='kwargs', defaults=(11, 'CHN'))</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><strong>getmro(cls):&nbsp;<br /></strong>返回一个类型元组，查找类属性时按照这个元组中的顺序。如果是新式类，与cls.__mro__结果一样。但旧式类没有__mro__这个属性，直接使用这个属性会报异常，所以这个方法还是有它的价值的。</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">#coding:utf-8<br />
import inspect

class A(object):<br />
    pass

class B(object):<br />
    pass

class C(A, B):<br />
    pass

print inspect.getmro(C)<br />
print C.__mro__<br />
print C.mro()<br />
"""<br />
(&lt;class '__main__.C'&gt;, &lt;class '__main__.A'&gt;, &lt;class '__main__.B'&gt;, &lt;type 'object'&gt;)<br />
(&lt;class '__main__.C'&gt;, &lt;class '__main__.A'&gt;, &lt;class '__main__.B'&gt;, &lt;type 'object'&gt;)<br />
[&lt;class '__main__.C'&gt;, &lt;class '__main__.A'&gt;, &lt;class '__main__.B'&gt;, &lt;type 'object'&gt;]<br />
"""</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwo5ll9.html">一段freemarker高级分页效果的代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlo5g0q.html">使用bootstrap tooltip控件动态修改提示内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/49574jzq.html">css样式 --- CSS hack</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv724zq.html">分页查询的SQL语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2nkkvq.html">C&num; Winform 脱离 Framework &lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvprdoq.html">HR外包系统 - 客户公司薪资规则 报表需求 记入系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q760ek8.html">怎样写 OpenStack Neutron 的 Extension （一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1lkjx8.html">&lbrack;&period;Net MVC&rsqb; 使用SQL Server数据库代替LocalDb</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xlgnz8.html">Hibernate查询之SQL查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kkk149.html">Java对于私有变量&OpenCurlyDoubleQuote;反思暴力&rdquo;技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpp6lzq.html">springMVC项目异步错误处理请求Async support must be enabled on a servlet and for all filters involved in async</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zjzwn9.html">CSharp设计模式读书笔记（23）：模板方法模式&lpar;学习难度：&starf;&starf;&star;&star;&star;，使用频率：&starf;&starf;&starf;&star;&star;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1zrwoq.html">ios上 更改 状态栏&lpar;UIStatusBar&rpar;的颜色，你值得一看、收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z0gx39.html">20190421-那些年使用过的CSS预处理器（CSS Preprocessor）之Sass and Less</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r777j9.html">ltp-ddt nor&lowbar;mtd&lowbar;dd&lowbar;rw&lowbar;jffs2</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1gekxq.html">python conv2d scipy卷积运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o132dlq.html">【转】&commat;RequestBody注解出现的三点错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1xr6e9.html">scala spark 机器学习初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r0wej9.html">IntelliJ IDEA 中文乱码配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gklomq.html">标准库 time</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zkd3on8.html">【BZOJ】4316&colon; 小C的独立集 静态仙人掌</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj3k668.html">Oozie与Coordinator调度讲解及系统时区配置与定时触发两种配置方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pp02md9.html">RMQ之ＳＴ求区间最大值</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvm0gjq.html">面向过程编程&lpar;OPP&rpar; 和面向对象编程&lpar;OOP&rpar;的关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v0djzq.html">BBScan &mdash; 一个信息泄漏批量扫描脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmwg009.html">Mac Sublime Vim模式 方向键无法长按</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pek2w8.html">juey点击tr选中里面的radio</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v02g6q.html">华东师范大学第十届ECNU  Coder程序设计竞赛</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4zw3xq.html">&lbrack;转载&rsqb;FFmpeg完美入门&lbrack;3&rsqb; - FFmpeg功能及使用说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2pr3z8.html">Linux删除除了今天以外的文件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
